Page MenuHomePhabricator

New comment shows up as an added space in the content in the VisualDiff
Closed, ResolvedPublic8 Story Points

Description

This should be accompanied by an annotation in the sidebar.

Event Timeline

Restricted Application added a project: VisualEditor. · View Herald TranscriptJul 10 2017, 11:38 AM
Restricted Application added a subscriber: Aklapper. · View Herald Transcript
Deskana triaged this task as Normal priority.Jul 10 2017, 2:30 PM
Deskana moved this task from To Triage to TR6: Visual diffs on the VisualEditor board.

This is a bit more complicated than it looks - we don't have a way yet of describing changes for a newly inserted/deleted node - only changes to an existing node. We should think about other cases that this would apply to (e.g. invisible templates) and come up with a general solution.

E.g. in how much detail do we describe the inserted/removed item? Do we just show the green/red highlight in the document, or a bit more, e.g. to indicate that it's a comment? Or if we show too much in the document are we wandering into editing rather than reading territory? Or should we have some generic icon for an invisible item?

HTML comments in articles are very rare in articles nowadays. Most of the use cases that exist for HTML comments are now served by edit notices, and the only use case that I know of that's left is annotating specific bits of the article, such as telling people not to change Obama's name.

What's an invisible template in this context? I assume a template like Template:Use American English is considered invisible because it's modifies categories. What about something like Template:Pp, where the banner it shows is suppressed if there's a small=yes parameter added to the transclusion but it still shows a padlock symbol at the top right outside the content area?

Sorry, I meant any template that isn't visible when just reading the article.

Working from the assumption (which may be wrong) that the visual diff is supposed to provide a read-like experience, then it would be inconsistent to show comments/templates that are only visible in edit mode. On the other hand, the current situation - just showing a green/red highlight with no explanation - isn't ideal either. I wonder if it should be a blue highlight with an explanation in the side bar, e.g. as currently when a comment is changed. I guess blue signifies that something changed behind the scenes, that can't be fully explained by highlighting the visible content red or green.

This is a bit more complicated than it looks - we don't have a way yet of describing changes for a newly inserted/deleted node - only changes to an existing node. We should think about other cases that this would apply to (e.g. invisible templates) and come up with a general solution.
E.g. in how much detail do we describe the inserted/removed item? Do we just show the green/red highlight in the document, or a bit more, e.g. to indicate that it's a comment? Or if we show too much in the document are we wandering into editing rather than reading territory? Or should we have some generic icon for an invisible item?

One of the things that I was thinking was that we could at least show a representative icon, instead of an empty green square. It would make sense to reuse the same icon as we are during editing. For example:

(aside: for comments, why do we use the alert icon when we have a comment icon? Should I raise a task for this?)

We could also add comments in the side bar to show a summary of what has changed.

I am not sure if this a good idea, but a (see more) link could expand right there to show which field have been entered with what values.


Can the hidden items be divided into two broad classes:

  1. Position based: For example: comments that are tied to the specific position they are at in the document.
  2. Page based: For example: a hidden template that adds a category to the page.

Do you think that showing the page based changes in a footer (like the sidebar) would make sense, instead of showing there details on where the show up in the page (as that doesn't matter any way). It would, however, show lesser information than we have.


Working from the assumption (which may be wrong) that the visual diff is supposed to provide a read-like experience, then it would be inconsistent to show comments/templates that are only visible in edit mode.

As I previously mentioned, I am confused about this too. Is VisualDiff supposed to be visual representation of the entire diff, or a diff of the visual changes?

Deskana set the point value for this task to 1.Aug 22 2017, 2:22 PM

Change 429569 had a related patch set uploaded (by Esanders; owner: Esanders):
[VisualEditor/VisualEditor@master] Use CE rendering when showing comments in preview mode (e.g. visual diff)

https://gerrit.wikimedia.org/r/429569

Change 429569 merged by jenkins-bot:
[VisualEditor/VisualEditor@master] Use CE rendering when showing comments in preview mode (e.g. visual diff)

https://gerrit.wikimedia.org/r/429569

Change 429832 had a related patch set uploaded (by Jforrester; owner: Jforrester):
[mediawiki/extensions/VisualEditor@master] Update VE core submodule to master (099902ddb)

https://gerrit.wikimedia.org/r/429832

Change 429832 merged by jenkins-bot:
[mediawiki/extensions/VisualEditor@master] Update VE core submodule to master (099902ddb)

https://gerrit.wikimedia.org/r/429832

Jdforrester-WMF changed the point value for this task from 1 to 8.
Deskana closed this task as Resolved.May 10 2018, 1:03 PM